/* global MembershipInterface */

(function(){

    "use strict";

    // add the response listener
    window.addEventListener('message', function(event) {

        // log the response
        var data = event.data.data;
        switch (event.data.method) {

            case "resetPass":
                $('#reset-pass-form input[type=submit]').val("RESET PASSWORD").removeAttr("disabled");
                if (event.data.data.success === false) {
                    $('#reset-pass-form .error').html(event.data.data.message).fadeIn();
                    return;
                }

                alert("YOUR PASSWORD HAS BEEN UPDATED SUCCESSFULY");
                window.location = "index.html";
                break;
        }
    });

    function getUrlVars() {
        var vars = {};
        var parts = window.location.href.replace(/[?&]+([^=&]+)=([^&]*)/gi, function(m,key,value) { vars[key] = value;
        });

        return vars;
    }

    $(function() {

        // verify that key and username vars exists
        var params = getUrlVars();
        if (params.key === undefined || params.username === undefined) {
            window.location = "index.html";
            return;
        }

        $("input[name=username]").val(params.username);

        $("#reset-pass-form").submit(function() {
            // get the input values
            var newPassword = $(this).find('input[name=password]').val().trim();
            var newPassword2 = $(this).find('input[name=password2]').val().trim();

            // must add a password
            $(this).find('.error').hide();
            if (newPassword === "" || newPassword2 === "") {
                $(this).find('.error').html("Both fields are required").fadeIn();
                return false;
            }

            // passwords must match
            $(this).find('.error').hide();
            if (newPassword !== newPassword2) {
                $(this).find('.error').html("Passwords don't match").fadeIn();
                return false;
            }

            // validate the hash key
            $(this).find('input[type=submit]').val("SENDING...").attr("disabled", true);
            MembershipInterface.resetPass('ms-frame', newPassword, params.key);
            return false;
        });

    });

})();
