/* global MembershipInterface */

(function(){

    "use strict";

    // add the response listener
    window.addEventListener('message', function(event) {

        // log the response
        var data = event.data.data;
        switch (event.data.method) {

            case "getUser":
                // if user is null, redirect to home
                if (data.user === null) {
                    window.location = "index.html";
                    return;
                }

                // create a fullname string
                var fullName = data.user.lastName + ' ' + data.user.firstName;
                fullName += (data.user.middleName == null ? "":" "+data.user.middleName)

                // show name, username and enable submit button
                $('.username-complete').html(fullName);
                $('input[name=username]').val(data.user.username);
                $('#sec-questions-form input[type=submit]').removeAttr("disabled");
                break;

            case "updateQuestions":
                $('#sec-questions-form input[type=submit]').val("SUBMIT").removeAttr("disabled");
                if (data.success === undefined) {
                    $('#sec-questions-form .error').html("ERROR").fadeIn();
                    return;
                }

                if (data.success === false) {
                    $('#sec-questions-form .error').html(data.message).fadeIn();
                    return;
                }

                alert("YOUR SECURITY QUESTIONS HAS BEEN UPDATED SUCCESSFULY");
                window.location = "index.html";
                break;
        }
    });

    $(function() {

        $('#ms-frame').on('load', function() {
            MembershipInterface.getUser('ms-frame');
        });

        $('#sec-questions-form').submit(function() {

            var q1 = $(this).find("[name=q1]").val().trim();
            var a1 = $(this).find("[name=a1]").val().trim();
            var q2 = $(this).find("[name=q2]").val().trim();
            var a2 = $(this).find("[name=a2]").val().trim();
            var q3 = $(this).find("[name=q3]").val().trim();
            var a3 = $(this).find("[name=a3]").val().trim();

            $(this).find(".error").hide();
            if (q1 === "" || a1 === "" ||
                q2 === "" || a2 === "" ||
                q3 === "" || a3 === "") {

                $(this).find(".error").html("All information is required").fadeIn();
                return false;
            }

            $(this).find('input[type=submit]').val("SENDING...").attr("disabled", true);
            MembershipInterface.updateQuestions('ms-frame', q1, a1, q2, a2, q3, a3);
            return false;
        });

    });

})();
