<?php
//	Script Version 7.5.7

// Require the library
require ("../libs/admin.inc.php");
require ("../languages/{$config['LANGUAGE']}/admin/forumperms.php");
require ("../languages/{$config['LANGUAGE']}/admin/generic.php");

// -------------
// Get the input
$returntab = get_input("returntab","both");
$edit_forum = get_input("edit_forum","both");
$copy_forum = get_input("copy_forum","both");

if (!$edit_forum) $edit_forum = 0;

// -----------------
// Get the user info

$userob = new user;
$user = $userob -> authenticate("USER_DISPLAY_NAME");

$admin = new Admin;

$admin->doAuth();

// Get the max size for file uploads
$max_file = ini_get("upload_max_filesize");

// Change some of the wordlets to include this size
$ubbt_lang['FILE_SIZE_1'] = $html->substitute($ubbt_lang['FILE_SIZE_1'],array("MAX_SIZE"=>$max_file));
$ubbt_lang['GALLERY_SIZE_1'] = $html->substitute($ubbt_lang['GALLERY_SIZE_1'],array("MAX_SIZE"=>$max_file));

include("{$config['FULL_PATH']}/cache/forum_cache.php");
if (!sizeof($tree)) {
	list($tree,$style_cache,$lang_cache) = build_forum_cache();
} // end if


$perm_list = array();
$query = "
	select PERMISSION_NAME,PERMISSION_IS_HIGH,PERMISSION_IS_LOW
	from {$config['TABLE_PREFIX']}PERMISSION_LIST
	where PERMISSION_TYPE='forum'
	order by PERMISSION_ORDER
";
$sth = $dbh->do_query($query,__LINE__,__FILE__);
while($row = $dbh->fetch_array($sth)) {
	$perm_list[] = $row;
} // end while

// Grab all of the permissions for the forum we are editing
if ($edit_forum == 0) {
	$fselect = "New Forum Template";
} else {
	$fselect = $edit_forum;
} // end if

if ($copy_forum || $copy_forum == "0") {
	$fselect = $copy_forum;
} // end if

if ($fselect == '0') {
  $fselect = "New Forum Template";
}
$perms = array();
$query = "
	select *
	from {$config['TABLE_PREFIX']}FORUM_PERMISSIONS
	where FORUM_ID = ?
	order by GROUP_ID
";
$sth = $dbh->do_placeholder_query($query,array($fselect),__LINE__,__FILE__);
while($row = $dbh->fetch_array($sth,MYSQL_ASSOC)) {
	foreach($row as $k => $v) {
		if ($k == "FORUM_ID") continue;
		if ($k == "GROUP_ID") {
			$gid = $v;
			continue;
		}
		$perms[$k][$gid] = $v;
	}
}

// Now grab all groups
$groups = array();
$query = "
	select GROUP_ID,GROUP_NAME
	from {$config['TABLE_PREFIX']}GROUPS
	where GROUP_IS_DISABLED ='0'
	order by GROUP_ID
";
$sth = $dbh->do_query($query,__LINE__,__FILE__);
while(list($gid,$gname) = $dbh->fetch_array($sth)) {
	$groups[$gid] = $gname;
} // end while



$tabs = array(
	"{$ubbt_lang['FORUM_PERMS']}" => "",
	"{$ubbt_lang['MASS_COPY']}" => "",
);

$admin->setCurrentMenu($ubbt_lang['FORUM_PERMS']);
$admin->setPageTitle($ubbt_lang['FORUM_PERMS']);
$admin->sendHeader();
$admin->createTopTabs($tabs,$returntab);

// Include the template
include("../templates/default/admin/forumperms.tmpl");

$admin->sendFooter();
?>
