<?php

//	Script Version 7.5.7

if(!defined("UBB_MAIN_PROGRAM")) exit;

function page_doeditevent_gpc () {
	return array(
		"input" => array(
			"month" => array("month","post","int"),
			"day" => array("day","post","int"),
			"year" => array("year","post","int"),
			"subject" => array("subject","post",""),
			"comments" => array("comments","post",""),
			"recurring" => array("recurring","post","alpha"),
			"type" => array("type","post","alpha"),
			"deleteevent" => array("deleteevent","post",""),
			"entry" => array("entry","post","int"),
		),
		"wordlets" => array("doeditevent"),
		"user_fields" => "",
		"regonly" => 1,
		"admin_only" => 0,
		"admin_or_mod" => 0,
	);
} // end page_doeditevent_gpc

function page_doeditevent_run () {

	global $smarty,$user,$in,$ubbt_lang,$config,$forumvisit,$visit,$dbh,$var_start,$var_eq,$var_sep,$var_extra;

	extract($in, EXTR_OVERWRITE | EXTR_REFS); // quick and dirty fix - extract hash values as vars
	
	$html = new html;
	
	$default_comments = $comments;


	// --------------------------
	// Can they edit this event?
	$query = "
	SELECT USER_ID
	FROM    {$config['TABLE_PREFIX']}CALENDAR_EVENTS
	WHERE  CALENDAR_EVENT_ID = ?
	";
	$sth = $dbh -> do_placeholder_query($query,array($entry),__LINE__,__FILE__);
	list ($owner) = $dbh -> fetch_array($sth);

	if ($owner != $user['USER_ID'] && $user['USER_MEMBERSHIP_LEVEL'] != "Administrator") {
		$html -> not_right("{$ubbt_lang['NO_EDIT']}");
	}
	
	$cfrm = make_ubb_url("ubb=cfrm", "", false);

	// --------------------------
	// Are we deleting the event?
	if ($deleteevent) {

		$smarty_data = array(
			"entry" => $entry,
			"month" => $month,
			"year" => $year,
		);

		return array(
			"header" => array (
				"title" => $ubbt_lang['DELETE_HEAD'],
				"refresh" => 0,
				"user" => $user,
				"Board" => "",
				"bypass" => 0,
				"onload" => "",
				"breadcrumb" => <<<BREADCRUMB
 <a href="{$cfrm}">{$ubbt_lang['FORUM_TEXT']}</a>
 &raquo;
 {$ubbt_lang['DELETE_HEAD']}
BREADCRUMB
				,
			),
			"template" => "doeditevent_delete",
			"data" => & $smarty_data,
			"footer" => true,
			"location" => "",
		);

	}


	// -----------------------------------
	// Make sure we at least got a subject
	if (!$subject) {
		$html -> not_right("{$ubbt_lang['ALL_FIELDS']}");
	}

	// ------------------
	// Update this event
	$subject = str_replace("&","&amp;",$subject);
	$subject = str_replace("<","&lt;",$subject);
	$comments = $html->do_markup($comments,"post","markup");

	$query_vars = array($day,$month,$year,$recurring,$subject,$comments,$default_comments,$type,$entry);
	
	$query = "
	UPDATE {$config['TABLE_PREFIX']}CALENDAR_EVENTS
	SET CALENDAR_EVENT_DAY = ? ,
	CALENDAR_EVENT_MONTH = ? ,
	CALENDAR_EVENT_YEAR  = ? ,
	CALENDAR_EVENT_RECURRING = ? ,
	CALENDAR_EVENT_SUBJECT = ? ,
	CALENDAR_EVENT_BODY = ? ,
	CALENDAR_EVENT_DEFAULT_BODY = ? ,
	CALENDAR_EVENT_TYPE = ?
	WHERE CALENDAR_EVENT_ID = ?
	";
	$dbh -> do_placeholder_query($query,$query_vars,__LINE__,__FILE__);

	$html->send_redirect(
		array(
			"redirect" => "calendar&month=$month&year=$year",
			"heading" => $ubbt_lang['HEAD'],
			"body" => $ubbt_lang['BODY'],
			"returnlink" => "",
			"breadcrumb" => <<<BREADCRUMB
 <a href="{$cfrm}">{$ubbt_lang['FORUM_TEXT']}</a>
 &raquo;
 {$ubbt_lang['HEAD']}
BREADCRUMB
			,
		)
	);

}
?>
