<?php
//	Script Version 7.5.7

if (!defined('INCLUDE_TAB')) exit;

$topics = array();

// Grab this user's favorite forums
$query = "
	SELECT	wl.WATCH_ID, f.FORUM_TITLE
		FROM	{$config['TABLE_PREFIX']}WATCH_LISTS wl,
					{$config['TABLE_PREFIX']}FORUMS f
	WHERE		wl.USER_ID = {$user['USER_ID']}
		AND		wl.WATCH_ID = f.FORUM_ID
		AND		wl.WATCH_TYPE = 'f'
";
$sth = $dbh->do_query($query,__LINE__,__FILE__);

$in_list = array();
$forums = array();

if ($filter) {
	$filter_links = "<tr><td class='popup_menu_content'><a href='" . make_ubb_url("ubb=myhome&tab=$tab&type=$type&sort=$sort", "", false) . "'>{$ubbt_lang['ALL_FORUMS']}</a></td></tr>";
}

while(list($fid,$name) = $dbh->fetch_array($sth)) {
	if ($userob->check_access("forum","READ_TOPICS",$fid)) {
		$filter_links .= "<tr><td class='popup_menu_content'><a href='" . make_ubb_url("ubb=myhome&tab=$tab&type=$type&sort=$sort&filter=$fid", "", false) . "'>{$ubbt_lang['SHOW_ONE']} $name</a></td></tr>";
		if ($filter && $fid != $filter) continue;
		$forums[$fid] = $name;
		$in_list[] = $fid;
	}
}

$smarty->assign("filter_links",$filter_links);

if (!sizeof($in_list)) {

	// We have no favorite forums
	$smarty->assign('display_no_favs',1);
	$smarty->assign('no_favs',$ubbt_lang['NO_FAV_FORUMS']);

} else {

	// We have favorite forums, display in list mode
	$smarty->assign('display_no_favs',0);
	$smarty->assign('favorite_users',0);

	// Let's see how many total topics we have
	$query = "
		select 	sum(FORUM_TOPICS)
		from		{$config['TABLE_PREFIX']}FORUMS
		where		FORUM_ID IN ( ? )
	";
	$sth = $dbh->do_placeholder_query($query,array($in_list),__LINE__,__FILE__);
	list($total_topics) = $dbh->fetch_array($sth);

	$topics_per = array_get($user,'USER_TOPICS_PER_PAGE',$config['TOPICS_PER_PAGE']);

	// We need to paginate this
	$total_pages = ceil($total_topics / $topics_per);
	$pages1 = $html->paginate($page,$total_pages,"myhome&tab=$tab&sort=$sort&filter=$filter&page=");
	$pages2 = preg_replace('#pagination_\d+#', '', $pages1);
	$smarty->assign_by_ref("pages1",$pages1);
	$smarty->assign_by_ref("pages2",$pages2);

	// Current topics per page is 1
	$limit_clause = "";
	if ($page <= 1) {
		$limit_clause = "limit $topics_per";
	} else {
		$limit_clause = "limit " . ($page - 1) * $topics_per . ",$topics_per";
	}

	// We need the icon, subject, author and time posted
	$query = "
		SELECT t.TOPIC_ID,t.POST_ID,t.USER_ID,t.TOPIC_SUBJECT,t.TOPIC_ICON,t.TOPIC_CREATED_TIME,
					 u.USER_DISPLAY_NAME,t.TOPIC_LAST_REPLY_TIME,t.FORUM_ID,u.USER_MEMBERSHIP_LEVEL,
					 up.USER_NAME_COLOR
		FROM {$config['TABLE_PREFIX']}TOPICS t,
				 {$config['TABLE_PREFIX']}USERS u,
				 {$config['TABLE_PREFIX']}USER_PROFILE up
		WHERE	TOPIC_IS_APPROVED = '1'
			AND	t.USER_ID = u.USER_ID
			AND u.USER_ID = up.USER_ID
			AND	t.FORUM_ID IN ( ? )
		ORDER BY $field_sort
		$limit_clause
	";
	$sth = $dbh->do_placeholder_query($query,array($in_list),__LINE__,__FILE__);
	$topic_key = 0;
	while(list($topic_id,$post_id,$user_id,$topic_subject,$topic_icon,$topic_created,$display_name,$last_reply,$forum_id,$level,$color) = $dbh->fetch_array($sth)) {

		if ($user_id == 1) {$display_name = $ubbt_lang['ANON_TEXT']; }
		$gonew = "";
		$folder = "nonewfolder.gif";
		if (isset($_SESSION['forumvisit']['visit'][$forum_id]) && $last_reply > $_SESSION['forumvisit']['visit'][$forum_id]) {
			$gonew = "&gonew=1#UNREAD";
			$folder = "newfolder.gif";
		}
		if (isset($_SESSION['topicread'][$topic_id]) && $_SESSION['topicread'][$topic_id] > $last_reply) {
			$gonew = "";
			$folder = "nonewfolder.gif";
		}

		$topics[$topic_key]['folder'] = "<img src='{$config['BASE_URL']}/images/{$style_array['general']}/$folder' alt='' />";
		$topics[$topic_key]['icon'] = "<img src='{$config['BASE_URL']}/images/{$style_array['icons']}/$topic_icon' alt='' />";
		$topics[$topic_key]['subject'] = "<a href=\"" . make_ubb_url("ubb=show{$user['USER_TOPIC_VIEW_TYPE']}&Number=$post_id$gonew", $topic_subject, false) . "\">$topic_subject</a>";
		if ($user_id != 1) {
			$display_name = $html->user_color($display_name,$color,$level);
			$topics[$topic_key]['author'] = "<a href='" . make_ubb_url("ubb=showprofile&User=$user_id", $display_name, false) . "'>$display_name</a>";
		} else {
			$topics[$topic_key]['author'] = "$display_name";
		}
		$topics[$topic_key]['posted'] = $html->convert_time($topic_created,$user['USER_TIME_OFFSET'],$user['USER_TIME_FORMAT']);
		$topics[$topic_key]['forum'] = $forums[$forum_id];
		$topics[$topic_key]['color'] = ($topic_key&1) ? "alt-topicsubject" : "topicsubject";
		$topic_key++;
	} // end while

	$smarty->assign_by_ref("topics",$topics);
}

?>
